"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupJQuery = exports.pageExtend = void 0;
const puppeteer_1 = require("puppeteer");
const jQueryPlugin_1 = require("./jQueryPlugin");
function applyMixins(dest, sources) {
    const destProto = dest.prototype || dest.__proto__;
    for (const baseCtor of sources) {
        const srcProto = baseCtor.prototype || baseCtor.__proto__;
        Object.getOwnPropertyNames(srcProto)
            .filter(name => !destProto[name])
            .forEach(name => {
            const propDef = Object.getOwnPropertyDescriptor(srcProto, name);
            Object.defineProperty(destProto, name, propDef);
        });
    }
    ;
}
const pageExtend = (page) => {
    applyMixins(page, [jQueryPlugin_1.JQueryAble]);
    return page;
};
exports.pageExtend = pageExtend;
async function setupJQuery(options) {
    if (!options)
        options = { headless: true };
    let browser = await puppeteer_1.launch(options);
    let page = await browser.newPage();
    exports.pageExtend(page);
    return browser;
}
exports.setupJQuery = setupJQuery;
